<?php
/**
 * @author Petr Ruttkay
 *
 */
/**
 * Funkce vrací denní kurz české měny k euru dle České národní banky.  
 * https://cnb.cz/cs/financni-trhy/devizovy-trh/kurzy-devizoveho-trhu/kurzy-devizoveho-trhu/denni_kurz.txt<BR>
 * Formát souboru:<BR>
 * 21.03.2024 #58<BR>
 * země|měna|množství|kód|kurz<BR>
 * Austrálie|dolar|1|AUD|15,273<BR>
 * Brazílie|real|1|BRL|4,660<BR>
 * Bulharsko|lev|1|BGN|12,909<BR>
 * Čína|žen-min-pi|1|CNY|3,216<BR>
 * Dánsko|koruna|1|DKK|3,386<BR>
 * EMU|euro|1|EUR|25,250<BR>
 * @return string|number
 */
function getKurzEUR()
{
    $url = "https://cnb.cz/cs/financni-trhy/devizovy-trh/kurzy-devizoveho-trhu/kurzy-devizoveho-trhu/denni_kurz.txt";
    
    try
    {
        // otevře soubor $file pro čtení
        $file = fopen($url,"r");
        
        // pokud bude server nedostupný nebo nebude existovat soubor funkce vráží kurz 25 Kč za 1 Euro
        if (!$file) return "25.0";
        
        while (!feof ($file))
        {
            $tmpList[] = chop(fgets($file, 4096));
        }
        
        fclose($file);
        
        // v prvním řádku souboru je datum – datum ve formátu d.m.Y
        $aktDate = substr($tmpList[0], 0, 10);
        $_SESSION['kurz_EUR_datum'] = $aktDate;
        
        $row = array(8); //array(8, 13,5,17,18,16);
        // pole $row obsahuje údaje s kurzy získanými z ČNB
        for ($i = 0; $i<count($row); $i++)
        {
            $pomTxt = explode("|",$tmpList[($row[$i]-1)]);
                     $kodMeny = $pomTxt[3];
                     //$mnozstvi = $pomTxt[2];
            if ($kodMeny == "EUR") {
                $kurz = str_replace(",", ".", $pomTxt[4]);
            }
        }
        
    }
    catch (Exception $e)
    {
        $kurz = "25.0";
    } 
    
    $kurz = round($kurz, 2);
    
    return $kurz;
    
}
 
?> 