<?php
/**
 * @author Petr Ruttkay
 *
 */
require_once "./_func/modelPdoFactory.php";
require_once "./_func/errorlib.php";
require_once "./_class/prHtmlForm.php";
require_once "./_class/prHtmlTable.php";
require_once "./_class/prProgress.php";
require_once "./_func/datetime_lib.php";
require_once "./_func/format.php";
require_once "./_class/formXmlRead.php";
require_once "./_class/formBoxCreator.php";
require_once "./_class/formCheck.php";
require_once "./_class/formCore.php";
require_once "./model/modelProcessFunc.php";

/**
 * Společná třída pro vyrvoření jednoduchého HTML formuláře. 
 *
 */
class CommonForm extends FormCore
{
   private $pdo;
   private $formStructure;

   private $keyName;

   public function __construct(modelPdo $pdo, $keyName, FormStructure $formStructure)
   {       
       $this->pdo = $pdo;
       $this->formStructure = $formStructure;
       $this->keyName = $keyName;
       
       parent::__construct($pdo, $keyName, $formStructure);       
   }


   public function run()
   {
       parent::setTempFlag(false);
       parent::setPregressText(null);
       
       parent::run();

       if (strpos($this->keyName, "vstupní hodnoty modelu") > 0) {
           $this->actionForm4ModelData();
       }
       
   }
   
   public function actionForm4ModelData(){
       
//        parent::actionForm(); //Odkometovat pokud se má použít funkce rodiče

       $formEditAction = parent::getFormEditAction();
       
       if ($formEditAction->wasSentButton(FormTableCreator::ACTION_SAVE_LINES) ||
           $formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_UPD_SAVE))
       {
           //Aktulazace dat
           saveModelData($this->pdo);
       }
       
       
       if ($formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_INS_SAVE)){
           saveModelData($this->pdo);
       }
       
   }
}
