<?php
/**
 * @author Petr Ruttkay
 *
 */

require_once "./_class/formPostDataLib.php";
require_once "./model/modelProcessFunc.php";

/**
 * Třída na zápis dat modelu CEVEMA+
 *  
 * @author Petr Ruttkay
 *
 */
class InsertModelInp
{
   private $pdo;
   private $formStructure;
   private $new_flag;
   private $name;
   private $msg;
   private $primaryKey;
   private $referTables= array();
   private $descColumns= array();


   public function __construct(modelPdo $pdo, $name, FormStructure $formStructure, $new_flag)
   {
      $this->pdo = $pdo;
      $this->formStructure = $formStructure;

      $this->name = $name;
      $this->new_flag = $new_flag;
   }



   /**
    * Funkce provede zápis pracovních dat
    * 
    * @param String $nameRow - Název řádky pro msg
    * @param modelPdo $pdo
    * @param boolean $tempFlag - TRUE platný záznam, False neplatný (pracovní) záznam
    * @return string|NULL|string - chybová nebo informatívní zpráva
    */
   public function InsertTempData($nameRow, modelPdo $pdo, $tempFlag)
   {
       if (isset($_SESSION["detl_ID"]) && $_SESSION["detl_ID"] != null) {
           return "";
       }
       $pdo->beginTransaction();
       
       
       $msg = null;
       
       
       $insertSql = "insert into ". $_SESSION["database"] . ".";
       $valuesSql =  " values (";
       $carka = "";
       $actualTable = null;
       
       foreach ($_REQUEST as $key => $value)
       {
           
           if (strlen($value) > 0 && strpos($key, "EW_REC_gridID_") > 0){
               
               list ($akceID, $primaryColumn, $table, $column) = explode('_#_', $key);
               
               if ($actualTable == null){
                   $actualTable = $table;
                   $insertSql = "insert into ". $_SESSION["database"] . ".";
                   $valuesSql =  " values (";
                   $carka = "";
               }
               if ($actualTable != null && $actualTable != $table){
                   //Zpracováva se další tabulka musí se prvést zápis první tabulky
                   $msg = $this->insertTable($pdo, $carka, $tempFlag, $insertSql, $valuesSql, $nameRow);   
                   
                   //Zpracováva se další tabulka musí se provést zápis první tabulky
                   $actualTable = $table;
                   $insertSql = "insert into ". $_SESSION["database"] . ".";
                   $valuesSql =  " values (";
                   $carka = "";
               }
               
               if ($primaryColumn == $column){
                   $primaryKeyValue = $value;
               } else if ($column == "id_modelinput" && $table == "modelresult"){
                   //Nastavení ID ze modelinp pro modelresult
                    echo "<BR>Nastavení ID z modelinp pro modelresult";
                   if (isset($_SESSION["save_primaryKey"]) && $_SESSION["save_primaryKey"] != null){
                       $value = $_SESSION["save_primaryKey"];
                   } else if (isset($_SESSION["head_ID"]) && $_SESSION["head_ID"] != null){
                       $value = $_SESSION["head_ID"];
                   } else {
                          $pdo->rollBack();
                          return "Napřed musí být zpasany vstupní údaje";
                      }
                   
               } else if ($column == "entry_code"){
                   $value = $_SESSION["is_user"];
               }
               
               if ($insertSql == "insert into ". $_SESSION["database"] . ".") {
                   $insertSql .= $table." (";
               }
               
               
               $insertSql .= $carka . $column;
               $valuesSql .= $carka . ":" . $column;
               
               
               
               if (isFormDate($column, $value)) {
                   //Jedná se o datum musí se konvertovat na SQL formát
                   $value = getDBDate($value);
               }
               $pdo->setNamedParam($column, $value);
               $carka = ", ";         
           }
           
       }
       
       //Zápis tabulky 
       $msg = $this->insertTable($pdo, $carka, $tempFlag, $insertSql, $valuesSql, $nameRow);   
       
       
       $sql = "select * from modelinp where entry_code= :entry_code and valid_flag = 0 ";
       $pdo->setNamedParam("entry_code", $_SESSION["is_user"]);
       
       foreach ($pdo->query($sql) as $data)
       {
           $modelInpID = $data["id"];
       }
       
       insertResult($pdo, $modelInpID);
       
       
       $pdo->commitTransaction();
       
       return $msg;
       
   }

   /**
    * Funkce zruší původní výsledky a zapíše nové
    * 
    * @param String $modelInpID
    * @param modelPdo $pdo
    * @return boolean - Chyba při potvrzení vstupů nebo při zápisu výsledků
    */
   public function updateResult($modelInpID, modelPdo $pdo)
   {
       
       if ($modelInpID == null) {
           return false;
       }
       $pdo->beginTransaction();
       
       
       $this->msg = null;
       
       $sql = "update modelinp set valid_flag = 0 where valid_flag = 1";
       if ($this->pdo->exec($sql) === false){
           $this->msg = "Chyba potvrzení vstupů";
           $pdo->rollBack();
           return false;
       }
       
       $sql = "delete from modelresult where id_modelinput = :id_modelinput ";
       $this->pdo->setNamedParam("id_modelinput", $modelInpID);
       if ($this->pdo->exec($sql) === false){
           $this->msg = "Chyba rušení původních výsledků";
           $pdo->rollBack();
           return false;
       }
       
       insertResult($pdo, $modelInpID);
       
       $pdo->commitTransaction();
       
       $this->msg = $this->name ." číslo " . $modelInpID ." úspešně zapsána.";
       
       $this->InsertData2DB("", $pdo);
       
       return true;
       
   }
   
   /**
    * Funkce provede potvrzení data (valid_flag = true) v tabulkách modelinp a modelresult
    * 
    * @param String $nameRow - Název řádky pro msg
    * @param modelPdo $pdo
    * @return boolean - Chyba potvrzení vstupů
    */
   public function InsertData2DB($nameRow, modelPdo $pdo)
   {
       $pdo->beginTransaction();
       
       
       $this->msg = null;
       $modelInpID = null;
       
       $sql = "select * from modelinp where valid_flag = 0 ";
       foreach ($this->pdo->query($sql) as $data)
       {
           $modelInpID = $data["id"];
       }
       
       $sql = "update modelinp set valid_flag = 1 where valid_flag = 0";
       if ($this->pdo->exec($sql) === false){
           $this->msg = "Chyba potvrzení vstupů";
           $pdo->rollBack();
           return false;
       }
       
       $sql = "update modelresult set valid_flag = 1 where id_modelinput = :id_modelinput and valid_flag = 0";
       $this->pdo->setNamedParam("id_modelinput", $modelInpID);
       if ($this->pdo->exec($sql) === false){
           $this->msg = "Chyba potvrzení výsledků";
           $pdo->rollBack();
           return false;
       }       
       
       $pdo->commitTransaction();
       
       $this->msg = $nameRow." číslo " . $modelInpID ." úspešně zapsána.";
       
       return true;

   }

   /**
    * Funkce provede zápis do DB tabulky dle parametrů funkce.
    * 
    * @param modelPdo $pdo
    * @param String $carka - ", " = Byl nastaven alespoň jeden sloupec
    * @param boolean $tempFlag  - TRUE platný záznam, False neplatný (pracovní) záznam 
    * @param String $insertSql - SQL příkaz pro zápis do do DB tabulky
    * @param String $valuesSql - Seznam hodnot oddělené čárkou  
    * @param String $nameRow   - Název řádky pro msg
    * @return NULL|string - chybová nebo informatívní zpráva
    */
   private function insertTable(modelPdo $pdo, $carka, $tempFlag, $insertSql, $valuesSql, $nameRow)
   {
       $msg = null;
       if ($carka == ", "){ //Byl nastaven alespoň jeden sloupec
           if ($tempFlag){
               $insertSql .= ", valid_flag)" . $valuesSql . ",0)";
           } else {
               $insertSql .= ", valid_flag)" . $valuesSql . ",1)";
               
           }

           $pdo->exec($insertSql);
           $newPrimaryKeyValue = $pdo->lastInsertId();
           
           if (strpos($insertSql, "modelinp") > 0){
               $_SESSION["head_ID"] =  $newPrimaryKeyValue;
           } else if (strpos($insertSql, "modelresult") > 0){
               $_SESSION["detl_ID"] =  $newPrimaryKeyValue;
           }
           $msg = $nameRow." ".$newPrimaryKeyValue." uspěšně zapsán.";
       }
       
       return $msg;
   }
   
    /**
     * Funkce vrací chybovou zprávu
     * @return string
     */
    public function getMsg()
    {
        return $this->msg;
    }
    /**
     * Funkce vrací primární klíč 
     * @return mixed
     */
    public function getPrimaryKey()
    {
        return $this->primaryKey;
    }

}