<?php
/**
 * @author Petr Ruttkay
 *
 */
require_once "./_func/modelPdoFactory.php";
require_once "./_func/errorlib.php";
require_once "./_class/prHtmlForm.php";
require_once "./_class/prHtmlTable.php";
require_once "./_class/prProgress.php";
require_once "./_func/datetime_lib.php";
require_once "./_func/format.php";
require_once "./_class/formXmlRead.php";
require_once "./_class/formBoxCreator.php";
require_once "./_class/formCheck.php";
require_once "./_class/formCore.php";
require_once "InsertModelInp.php";
require_once "./_func/modelCanvas.php";


class ModelCevema extends FormCore
{
    private $pdo;
    private $updateSQL;
    private $formStructure;
    
    private $keyName;
    private $typeModel;
    
    /**
     * 
     * @param modelPdo $pdo
     * @param string $keyName například CEVEMA
     * @param string $typeModel Typ modelu
     * @param FormStructure $formStructure
     */
    public function __construct(modelPdo $pdo,  $keyName, $typeModel, FormStructure $formStructure)
    {
        $this->pdo = $pdo;
        $this->formStructure = $formStructure;
        $this->keyName = $keyName;
        $this->typeModel = $typeModel;
        
        parent::__construct($pdo, $keyName, $formStructure);
    }
    
    
    public function run()
    {
       
        parent::setTempFlag(false); 
        parent::setInsertDocActive(false);
        
        parent::initFormCore();
        
        $this->fillID($this->typeModel);
        
        $this->actionForm();
        
        parent::genPage("Načítá se seznam dat");
        
        echo "\n";
        echo getModelCanvasScript($this->pdo, "003");
        
        echo "\n";
        echo "<script>";
        echo "\n";
        echo 'const selectElement = document.querySelector(".tableID_modelinp_kurz_currency_code"); ';
        echo "\n";
        echo 'const convQty = document.querySelector(".tableID_modelinp_kurz_conv_qty"); ';
        echo "\n";
        echo 'const resultCurr = document.querySelector(".resultCurr"); ';
        echo "\n";
        echo 'const convEur = "'.$_SESSION['kurz_EUR'].'";';
        echo "\n";
        echo 'const convCZK = "1";';
        echo "\n";
        echo ' selectElement.addEventListener("change", (event) => {';
        echo "\n";
        
        echo ' resultCurr.style.backgroundColor = "green";';
        echo 'if (selectElement.value == "EUR") {';
        echo 'convQty.value = convEur;';
        echo ' } else {';
        echo ' convQty.value = "1";';
        echo ' }';
        echo ' convQty.background = "green";';
        echo "\n";
        echo '         });';
        echo "\n";
        echo "</script>\n";
        echo "\n";        
        
    }
    
    public function actionForm(){
        
        //parent::actionFormCore(); Odkometovat pokud se má použít funkce rodiče
        
        $formEditAction = parent::getFormEditAction();
        
        
        if (!isset($_SESSION['model_input_flag'])) {
            $_SESSION['model_input_flag'] = true;
        } 
        if ($formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_INS_SAVE) ||
            $formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_UPD_SAVE)) {
            $_SESSION['model_input_flag'] = false;
        } else {
            $_SESSION['model_input_flag'] = true;
        }
        
        
        
        if ($formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_STORNO) ||
            $formEditAction->wasSentButton(FormGridCreator::ACTION_NEW_CEVEMA)) {
            unset($_SESSION['reading_result']);
            //Bylo stisknuto tlačítko STORNO nebo Nový zápis
            $sql = "delete from modelinp where entry_code= :entry_code and entry_date= :entry_date and valid_flag = 1 ";
            $this->pdo->setNamedParam("entry_code", $_SESSION["is_user"]);
            $this->pdo->setNamedParam("entry_date", date('Y-m-d'));
            
            $this->pdo->setNamedParam("entry_code", $_SESSION["is_user"]);
            if ($this->pdo->exec($sql) === false){
                return "Chyba filtru dat";
            }
            
            $_SESSION["primaryKey"] = null;            
            $_SESSION["save_primaryKey"] = null;
            $_SESSION["head_ID"] = null;
            $_SESSION["detl_ID"] = null;
            $_SESSION["insRow"] = "N";
            $_SESSION['model_input_flag'] = true;
        }
        
        //Přečtení výsledku speekrem
        if ($formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_READING)) {
            $postData = new FormPostDataLib(false);
            $dbTable = $postData->getTable();
            $sql = "select result_text from " . $dbTable . " where ".$dbTable.".valid_flag = 1 " . 
            " and $dbTable." . $postData->getColumn4Detail() . "= :" . $postData->getColumn4Detail() ;
            $this->pdo->setNamedParam($postData->getColumn4Detail(), $postData->getIdDetail());
            
            $_SESSION['model_input_flag'] = false;
            
            foreach ($this->pdo->query($sql) as $data) {
                $text = $data["result_text"];
                //TODO musí se vyházet tagy, tabulky a grafy 
            }

            if (isset($text)){
                echo "\n";
                echo "<script>";
                echo "\n";
                echo ' var msg = new SpeechSynthesisUtterance("' . $text . '"); ';
                echo "\n";
                echo ' //msg.rate = 0.9; ';
                echo "\n";
                echo ' window.speechSynthesis.speak(msg);';
                echo "\n";
                echo "</script>\n";
                echo "\n";                
            }
        }
        
        if ($formEditAction->wasSentButton(FormTableCreator::ACTION_SAVE_LINES) ||
            $formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_UPD_SAVE))
        {
            //Aktulazace dat
            $custCheck = new FormCheck($this->pdo, $this->keyName, $this->formStructure, false);
            
            if ($custCheck->checForm()){
                $msg = saveChanges($this->pdo);
                $doc = new InsertModelInp($this->pdo, "Změna - " . $this->keyName, $this->formStructure, false);
                if(!$doc->updateResult($_SESSION["primaryKey"], $this->pdo)) {
                    echo getErrorMsg($doc->getMsg());
                } else {
                    $this->fillID($this->typeModel);
                }                
            } else {
                $msg =$custCheck->getMsg();
                echo "<font color=red><b>".$msg."!</b></font>";
                
                $_SESSION["show_last_data"] = true;
                $_SESSION["primaryKey"]     = $custCheck->getPrimaryKey();
            }
            
            parent::setNoFiltred(false);
            $_SESSION["noFiltred"] = "N";
        }
        
        
        if ($formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_EDITOR_INS_SAVE) ||
            $formEditAction->wasSentButton(FormGridCreator::ACTION_GOTO_INS_DOC)){
            //Zápis nových dat
            $custCheck = new FormCheck($this->pdo, $this->keyName, $this->formStructure, true);
            
            if ($custCheck->checForm()){
                $doc = new InsertModelInp($this->pdo, "Zápis - " . $this->keyName, $this->formStructure, true);
                $msg = $doc->InsertTempData($this->keyName, $this->pdo, true);
                if (isset($msg)) {
                    if(!$doc->InsertData2DB($this->keyName, $this->pdo)) {
                        echo getErrorMsg($doc->getMsg());
                    } else {
                        $this->fillID($this->typeModel);
                        //                     echo getErrorMsg($msg);
                        $_SESSION["insRow"] = "Y";
                    }
                }
            } else {
                $msg =$custCheck->getMsg();
                echo "<font color=red><b>".$msg."!</b></font>";
                $_SESSION["show_last_data"] = true;
                $_SESSION["primaryKey"]     = null;
                $_SESSION["insRow"] = "N";
            }
            parent::setNoFiltred(false);
            $_SESSION["noFiltred"] = "N";
        }
    }
    
    private function fillID($type_model){
        
        $_SESSION["insRow"] = "N";
        $_SESSION["wherePartRow"] = " 1=0 "; //Aby se nevybrali řádky pokud se zapisuje nový doklad
        $sql = "select id, entry_date from modelinp where entry_code= :entry_code and entry_date= :entry_date and valid_flag = 1 order by entry_date, id desc";
        $this->pdo->setNamedParam("entry_code", $_SESSION["is_user"]);
        $this->pdo->setNamedParam("entry_date", date('Y-m-d'));
        
        foreach ($this->pdo->query($sql) as $data)
        {
            $value = $data["id"];
            $_SESSION["primaryKey"] = $value;
            
            $_SESSION["save_primaryKey"] = $value;
            $_SESSION["head_ID"] = $value;
            
            $_SESSION["wherePartRow"]  = " id_modelinput = " . $value; //Podmínka pro načtení řádek dokladu
            
           $sql = "select id from modelresult where id_modelinput = :id_modelinput and valid_flag = 1 order by line_num";
            $this->pdo->setNamedParam("id_modelinput", $value);
            foreach ($this->pdo->query($sql) as $detl)
            {
                $value = $detl["id"];
                $_SESSION["detl_ID"] = $value;
                $_SESSION["insRow"] = "Y";
                
                break;
            }
            break;
        }
        
    }
}
