<?php

/**
 * Funkce provede zápis výsledků do DB tabulky modelresult
 * 
 * @param modelPdo $pdo - PDO pro databázi
 * @param String $modelInpID - ID záznamu v tabulce modelinp 
 */
function insertResult(modelPdo $pdo, $modelInpID)
{
 
    $matPer = 0;
    $personPer = 0;
    $otherPer = 0;
    $sql  = " select 1 as row_id, (i.mat_cost_amt / i.conv_qty) / (i.mat_cost_amt / i.conv_qty + i.person_cost_amt / i.conv_qty + i.other_cost_amt / i.conv_qty) as perc ";
    $sql .= " from modelinp i ";
    $sql .= " where i.id = :id ";
    $sql .= " union ";
    $sql .= " select 2 as row_id, (i.person_cost_amt / i.conv_qty) / (i.mat_cost_amt / i.conv_qty + i.person_cost_amt / i.conv_qty + i.other_cost_amt / i.conv_qty) as perc ";
    $sql .= " from modelinp i ";
    $sql .= " where i.id = :id ";
    $sql .= " union ";
    $sql .= " select 3 as row_id, (i.other_cost_amt / i.conv_qty) / (i.mat_cost_amt / i.conv_qty + i.person_cost_amt / i.conv_qty + i.other_cost_amt / i.conv_qty) as perc ";
    $sql .= " from modelinp i ";
    $sql .= " where i.id = :id ";
    
    $pdo->setNamedParam("id", $modelInpID);
    
    foreach ($pdo->query($sql) as $data)
    {
        $rowId      = $data["row_id"];
        $perc      = $data["perc"];
        switch ($rowId){
            case 1:
                $matPer = $perc * 100;
                break;
            case 2:
                $personPer = $perc * 100;
                break;
            case 3:
                $otherPer = $perc * 100;
                break;
        }
    }
        
    $matPer = round($matPer, 0);
    $personPer = round($personPer, 0);
    $otherPer = round($otherPer, 0);
    
    $pdo->setNamedParam("id", $modelInpID);
    
        
    $sql = "select * from evaluationlist where valid_flag = 1 order by exit_type, eval_code";
    
    $lineNum = 0;
    foreach ($pdo->query($sql) as $data)
    {
        $lineNum ++;
        $exit_type      = $data["exit_type"];
        $eval_code      = $data["eval_code"];
        $eval_text      = $data["eval_text"];
        $column_name    = $data["column_name"];
        
        $amtFlag = false;
        $percFlag = false;
        if (strpos($column_name, "_amt") > 0 || $column_name == "fodder_qty") {
            $amtFlag = true;
        }
        if ($column_name == "mat_cost_amt" || $column_name == "person_cost_amt" || $column_name == "other_cost_amt") {
            $percFlag = true;
        }
        
        $insSQL  = "insert into modelresult (id_modelinput, line_num, exit_type, eval_code, type_ind, ";
        $insSQL .= " eval_text, result_text, valid_flag)";
        $insSQL .= "select i.id, ".$lineNum.", f.exit_type, f.eval_code, f.type_ind, '".$eval_text."',r.result_text, 0 ";
        $insSQL .= "from modeldata f, modeldata t, modelinp i, resulttextlist r ";
        $insSQL .= "where i.id = :id ";
        $insSQL .= "and f.exit_type = :exit_type ";
        $insSQL .= "    and f.eval_code = :eval_code ";
        $insSQL .= "        and f.interval_ind = 'F' ";
        $insSQL .= "            and t.interval_ind = 'T' ";
        $insSQL .= "                and f.country_code is null ";
        $insSQL .= "                and t.country_code is null ";
        if ($percFlag) {
            $insSQL .= "         and (i." . $column_name. " / i.conv_qty) / (i.mat_cost_amt / i.conv_qty + i.person_cost_amt / i.conv_qty + i.other_cost_amt / i.conv_qty) > f.value_qty";
            $insSQL .= "         and (i." . $column_name. " / i.conv_qty) / (i.mat_cost_amt / i.conv_qty + i.person_cost_amt / i.conv_qty + i.other_cost_amt / i.conv_qty) <= t.value_qty";
        } else if ($amtFlag) {
            $insSQL .= "                and i." . $column_name. " / i.conv_qty > f.value_qty  ";
            $insSQL .= "                and i." . $column_name. " / i.conv_qty <= t.value_qty ";
        } else {
            $insSQL .= "                and i." . $column_name. " > f.value_qty ";
            $insSQL .= "                and i." . $column_name. "  <= t.value_qty ";            
        }
        $insSQL .= "                and t.exit_type = f.exit_type ";
        $insSQL .= "                and t.eval_code = f.eval_code ";
        $insSQL .= "                and t.type_ind = f.type_ind ";
        $insSQL .= "                and r.exit_type = t.exit_type ";
        $insSQL .= "                and r.eval_code = t.eval_code ";
        $insSQL .= "                and r.row_ind = f.type_ind ";
        $insSQL .= "                and f.valid_flag= true ";
        $insSQL .= "                and t.valid_flag= true ";
        $insSQL .= "                and r.valid_flag= true ";
        
        $pdo->setNamedParam("id", $modelInpID);
        $pdo->setNamedParam("exit_type", $exit_type);
        $pdo->setNamedParam("eval_code", $eval_code);
        
        $pdo->exec($insSQL);
        
        $sql = "select r.row_ind , r.result_text ";
        $sql .= "from resulttextlist r ";
        $sql .= "where r.exit_type = :exit_type ";
        $sql .= "and r.eval_code = :eval_code ";
        $sql .= "and r.row_ind in ('1','2','3','4','5','6') ";
        $sql .= "and r.valid_flag = true ";
        $sql .= "order by 1 ";
        
        $pdo->setNamedParam("exit_type", $exit_type);
        $pdo->setNamedParam("eval_code", $eval_code);
        
        foreach ($pdo->query($sql) as $dataUPD)
        {
            $row_ind      = $dataUPD["row_ind"];
            $result_text      = $dataUPD["result_text"];
            
            $textReplace = "Text ". trim($row_ind) . ".";
            
            $updSQL  = "update modelresult ";
            $updSQL .= " set result_text = REPLACE(result_text, '". $textReplace."', '". $result_text."') ";
            $updSQL .= "where id_modelinput = :id_modelinput ";
            $updSQL .= "  and exit_type = :exit_type ";
            $updSQL .= "  and eval_code = :eval_code ";
            
            $pdo->setNamedParam("id_modelinput", $modelInpID);
            $pdo->setNamedParam("exit_type", $exit_type);
            $pdo->setNamedParam("eval_code", $eval_code);
            
            $pdo->exec($updSQL);

            $sqlInp  = "select ".$column_name." ";
            $sqlInp .= " from modelinp ";
            $sqlInp .= " where id = :id_modelinput ";

            $pdo->setNamedParam("id_modelinput", $modelInpID);
            
            foreach ($pdo->query($sqlInp) as $dataUPD2)
            {
                $inpValue   = $dataUPD2[$column_name];
                $inpValue = str_replace(".",",", $inpValue);
                
                $updSQL2  = "update modelresult ";
                $updSQL2 .= " set result_text = REPLACE(result_text, 'X,XX','". $inpValue."') ";
                $updSQL2 .= "where id_modelinput = :id_modelinput ";
                $updSQL2 .= "  and exit_type = :exit_type ";
                $updSQL2 .= "  and eval_code = :eval_code ";
                
                $pdo->setNamedParam("id_modelinput", $modelInpID);
                $pdo->setNamedParam("exit_type", $exit_type);
                $pdo->setNamedParam("eval_code", $eval_code);

                $pdo->exec($updSQL2);
                
                if ($eval_code == "004" || $eval_code == "005" || $eval_code == "006") {
                    $updSQL2  = "update modelresult ";
                    $updSQL2 .= " set result_text = REPLACE(result_text, '%mat%','". $matPer." %'), ";
                    $updSQL2 .= "     result_text = REPLACE(result_text, '%osob%','". $personPer." %'), ";
                    $updSQL2 .= "     result_text = REPLACE(result_text, '%ost%','". $otherPer." %') ";
                    $updSQL2 .= "where id_modelinput = :id_modelinput ";
                    $updSQL2 .= "  and exit_type = :exit_type ";
                    $updSQL2 .= "  and eval_code = :eval_code ";
                    
                    $pdo->setNamedParam("id_modelinput", $modelInpID);
                    $pdo->setNamedParam("exit_type", $exit_type);
                    $pdo->setNamedParam("eval_code", $eval_code);
                    
                    $pdo->exec($updSQL2);
                }
                
            }            
        }     
    }
   
}

/**
 * Funkce provede zápis z dat z tabulek modeldatamin modeldatamax do tabulky modeldata
 * 
 * @param modelPdo $pdo
 */
function saveModelData(modelPdo $pdo)
{   
    $pdo->beginTransaction();
    
    $sql = "select * from evaluationlist where valid_flag = 1 ";
    
    foreach ($pdo->query($sql) as $data)
    {
        $exit_type      = $data["exit_type"];
        $eval_code      = $data["eval_code"];
        $column_name    = $data["column_name"];
        
        $delSQL = "delete from modeldata where exit_type= :exit_type and eval_code= :eval_code and valid_flag = 1";
        $pdo->setNamedParam("exit_type", $exit_type);
        $pdo->setNamedParam("eval_code", $eval_code);
        $pdo->exec($delSQL);
        
        $sql = "";
        if ($exit_type == "1") {
            $sql .= "select type_ind, country_code, interval_ind, ".$column_name.
            "  from modeldatamin where valid_flag = 1 ";
        } else {
            $sql .= "select type_ind, country_code, interval_ind, ".$column_name.
            "  from modeldatamax where valid_flag = 1 ";
        }
        $sql .= " order by 1,2,3";
        
        
        foreach ($pdo->query($sql) as $data1)
        {
            $type_ind       = $data1["type_ind"];
            $country_code   = $data1["country_code"];
            $interval_ind   = $data1["interval_ind"];
            $value          =  $data1[$column_name];
            
            $insSql  = "insert into modeldata ";
            $insSql .= " (exit_type, eval_code, type_ind, country_code, interval_ind, value_qty, valid_flag) ";
            $insSql .= " values( ";
            $insSql .= " :exit_type, :eval_code,   :type_ind,";
            $insSql .= " :country_code, :interval_ind, :value_qty,";
            $insSql .= " 1) ";
            
            $pdo->setNamedParam("exit_type", $exit_type);
            $pdo->setNamedParam("eval_code", $eval_code);
            $pdo->setNamedParam("type_ind", $type_ind);
            
            if ($country_code == null) {
                $insSql = str_replace(":country_code", "null", $insSql);
            } else {
                $pdo->setNamedParam("country_code", $country_code);
            }
            if ($interval_ind == null) {
                $insSql = str_replace(":interval_ind", "null", $insSql);
            } else {
                $pdo->setNamedParam("interval_ind", $interval_ind);
            }
            
            $pdo->setNamedParam("value_qty", $value);
            
            $pdo->exec($insSql);
            
        }
        
    }
    
    $pdo->commitTransaction();
    
}

